Scriptname _TS_ActivatorScript extends ObjectReference  

_TS_QuestScript Property Libs Auto

GlobalVariable Property _TS_GlobalTrainDistance Auto
GlobalVariable Property _TS_GlobalMult Auto

Message Property _TS_MsgTrainWeaponMarksman Auto
Message Property _TS_MsgTrainWeaponOneHanded Auto
Message Property _TS_MsgTrainWeaponTwoHanded Auto

Message Property _TS_MsgTrainSpellAlteration Auto
Message Property _TS_MsgTrainSpellConjuration Auto
Message Property _TS_MsgTrainSpellDestruction Auto
Message Property _TS_MsgTrainSpellIllusion Auto
Message Property _TS_MsgTrainSpellRestoration Auto

Message Property _TS_MsgTrainedInCombat Auto
Message Property _TS_MsgTrainedTooExhausted Auto
Message Property _TS_MsgTrainedTooExhaustedStart Auto

Bool Property NoMelee Auto

Actor Property PlayerRef Auto

Sound Property WPNBowFire Auto
Sound Property WPNImpactAxeVsWood Auto
Sound Property MAGRuneImpact Auto
Sound Property MAGConjureImpact Auto
Sound Property MAGFireboltImpact Auto
Sound Property MAGRuneCast Auto
Sound Property MAGRestorationTurnUndeadFire2D Auto

Idle Property IdleCleanSword Auto
Idle Property IdleMagic_01 Auto

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	if(akAggressor as Actor && (akAggressor as Actor) == PlayerRef)
		if(akSource as Weapon)
			int Skill = Libs.GetWeaponSkill(akSource as Weapon)
			if(Libs.IsValidSkill(Skill) && (!NoMelee || Skill == 8))
				Libs.AdvanceSkill(Skill, 0.2 * _TS_GlobalMult.GetValue() * GetDistanceFactor() * libs.GetReducedSkillMult(Skill))
			else
				Debug.Notification("You cannot train with this weapon")
			endIf
		elseif(akSource as Spell)
			int Skill = Libs.GetSpellSkill(akSource as Spell)
			if(Libs.IsValidSkill(Skill))
				Libs.AdvanceSkill(Skill, 0.2 * _TS_GlobalMult.GetValue() * GetDistanceFactor() * libs.GetReducedSkillMult(Skill))
			else
				Debug.Notification("You cannot train with this spell")
			endIf
		endIf
	endIf
endEvent

Event OnActivate(ObjectReference akActionRef)
	if(akActionRef == PlayerRef)
		if(PlayerRef.IsInCombat())
			_TS_MsgTrainedInCombat.Show()
		else
			int EquippedType = PlayerRef.GetEquippedItemType(1)
			if(EquippedType >= 1 && (EquippedType <= 7 || EquippedType == 12))
				if(PlayerRef.GetActorValue("Stamina") < 10)
					_TS_MsgTrainedTooExhaustedStart.Show()
				elseif(EquippedType <= 4 && !NoMelee)		;One-Handed
					Libs.Train(6, _TS_GlobalMult.GetValue(), 2, true, _TS_MsgTrainWeaponOneHanded, _TS_MsgTrainedTooExhausted, IdleCleanSword, WPNImpactAxeVsWood)
				elseif(EquippedType <= 6 && !NoMelee)	;Two-Handed
					Libs.Train(7, _TS_GlobalMult.GetValue(), 2, true, _TS_MsgTrainWeaponTwoHanded, _TS_MsgTrainedTooExhausted, IdleCleanSword, WPNImpactAxeVsWood)
				elseif(EquippedType == 7 || EquippedType == 12)	;Marksman
					Libs.Train(8, _TS_GlobalMult.GetValue(), 2, true, _TS_MsgTrainWeaponMarksman, _TS_MsgTrainedTooExhausted, IdleCleanSword, WPNBowFire)
				else
					Debug.Notification("You cannot train with this weapon")
				endIf
			elseif(EquippedType == 9)
				int Skill = Libs.GetSpellSkill(PlayerRef.GetEquippedSpell(1))
				if(PlayerRef.GetActorValue("Magicka") < 10)
					_TS_MsgTrainedTooExhaustedStart.Show()
				elseif(Skill == 18)
					Libs.Train(Skill, _TS_GlobalMult.GetValue(), 2, false, _TS_MsgTrainSpellAlteration, _TS_MsgTrainedTooExhausted, IdleMagic_01, MAGRuneImpact)
				elseif(Skill == 19)
					Libs.Train(Skill, _TS_GlobalMult.GetValue(), 2, false, _TS_MsgTrainSpellConjuration, _TS_MsgTrainedTooExhausted, IdleMagic_01, MAGConjureImpact)
				elseif(Skill == 20)
					Libs.Train(Skill, _TS_GlobalMult.GetValue(), 2, false, _TS_MsgTrainSpellDestruction, _TS_MsgTrainedTooExhausted, IdleMagic_01, MAGFireboltImpact)
				elseif(Skill == 21)
					Libs.Train(Skill, _TS_GlobalMult.GetValue(), 2, false, _TS_MsgTrainSpellIllusion, _TS_MsgTrainedTooExhausted, IdleMagic_01, MAGRuneCast)
				elseif(Skill == 22)
					Libs.Train(Skill, _TS_GlobalMult.GetValue(), 2, false, _TS_MsgTrainSpellRestoration, _TS_MsgTrainedTooExhausted, IdleMagic_01, MAGRestorationTurnUndeadFire2D)
				else
					Debug.Notification("You cannot train with this spell")
				endIf
			else
				Debug.Notification("You need a weapon or spell equipped to train.")
			endIf
		endIf
	endIf
endEvent

float Function GetDistanceFactor()
	return Math.Pow((GetDistance(PlayerRef) - _TS_GlobalTrainDistance.GetValue())/_TS_GlobalTrainDistance.GetValue() + 1, 0.5)
endFunction