Scriptname _TS_AliasScript extends ReferenceAlias  

_TS_QuestScript Property Libs Auto

Keyword Property _TS_KeywordTrainedMagicka Auto
Keyword Property _TS_KeywordTrainedStamina Auto

Message Property _TS_MsgStudyConfirmation Auto
Message Property _TS_MsgStudyTooExhausted Auto
Message Property _TS_MsgStudyTooExhaustedStart Auto

FormList Property _TS_ListMsgStudy Auto

GlobalVariable Property _TS_GlobalMult Auto

Idle Property IdleBook_Reading  Auto  

Sound Property ITMBookPageTurnForward Auto

GlobalVariable Property GameDaysPassed Auto

float SleepStart = 0.0

Event OnInit()
	RegisterForSleep()
endEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	if(akBaseObject as Book && !GetActorRef().IsInCombat())
		int Skill = Libs.GetBookSkill(akBaseObject as Book)
		if(Libs.IsValidSkill(Skill))
			Utility.WaitMenuMode(1.5)
			if(_TS_MsgStudyConfirmation.Show() == 0)
				if(GetActorRef().GetActorValue("Magicka") > 0)
					Libs.Train(Skill, _TS_GlobalMult.GetValue() * 0.5, 1, false, _TS_ListMsgStudy.GetAt(Skill - 6) as Message, _TS_MsgStudyTooExhausted, IdleBook_Reading, ITMBookPageTurnForward)
				else
					_TS_MsgStudyTooExhaustedStart.Show()
				endIf
			endIf
		endIf
	endIf
endEvent

Event OnSleepStart(float afSleepStartTime, float afDesiredSleepEndTime)
	SleepStart = afSleepStartTime
endEvent

Event OnSleepStop(bool abInterrupted)
	float SleepTime = GameDaysPassed.GetValue() - SleepStart
	if(SleepTime > 0.2)
		if(GetActorRef().HasMagicEffectWithKeyword(_TS_KeywordTrainedMagicka))
			int MagickaRest = (-1 * SleepTime * 24 * (GetActorRef().GetBaseActorValue("Magicka")/100.0)) as int
			Libs.UpdateExhaustion(false, MagickaRest)
		endIf
		if(GetActorRef().HasMagicEffectWithKeyword(_TS_KeywordTrainedStamina))
			int StaminaRest = (-1 * SleepTime * 24 * (GetActorRef().GetBaseActorValue("Stamina")/100.0)) as int
			Libs.UpdateExhaustion(true, StaminaRest)
		endIf
	endIf
endEvent