Scriptname _TS_QuestScript extends Quest  

FormList Property _TS_ListBooksAlchemy Auto
FormList Property _TS_ListBooksAlteration Auto
FormList Property _TS_ListBooksBlock Auto
FormList Property _TS_ListBooksConjuration Auto
FormList Property _TS_ListBooksDestruction Auto
FormList Property _TS_ListBooksEnchanting Auto
FormList Property _TS_ListBooksHeavyArmor Auto
FormList Property _TS_ListBooksIllusion Auto
FormList Property _TS_ListBooksLightArmor Auto
FormList Property _TS_ListBooksLockpicking Auto
FormList Property _TS_ListBooksMarksman Auto
FormList Property _TS_ListBooksOneHanded Auto
FormList Property _TS_ListBooksPickpocket Auto
FormList Property _TS_ListBooksRestoration Auto
FormList Property _TS_ListBooksSmithing Auto
FormList Property _TS_ListBooksSneak Auto
FormList Property _TS_ListBooksSpeechcraft Auto
FormList Property _TS_ListBooksTwoHanded Auto

FormList Property _TS_ListKeywordsMarksman Auto
FormList Property _TS_ListKeywordsOnehanded Auto
FormList Property _TS_ListKeywordsTwoHanded Auto

FormList Property _TS_ListPerkAlteration Auto
FormList Property _TS_ListPerkConjuration Auto
FormList Property _TS_ListPerkDestruction Auto
FormList Property _TS_ListPerkIllusion Auto
FormList Property _TS_ListPerkRestoration Auto

FormList Property _TS_ListSpellsAlteration Auto
FormList Property _TS_ListSpellsConjuration Auto
FormList Property _TS_ListSpellsDestruction Auto
FormList Property _TS_ListSpellsIllusion Auto
FormList Property _TS_ListSpellsRestoration Auto

FormList Property _TS_ListSpellsTrainedMagicka Auto
FormList Property _TS_ListSpellsTrainedStamina Auto

GlobalVariable Property _TS_GlobalDrainedMagicka Auto
GlobalVariable Property _TS_GlobalDrainedStamina Auto

Keyword Property _TS_KeywordTrainedMagicka Auto
Keyword Property _TS_KeywordTrainedStamina Auto

Idle Property IdleStop_Loose Auto

GlobalVariable Property GameHour Auto

ImageSpaceModifier Property FadeToBlackImod  Auto  
ImageSpaceModifier Property FadeToBlackHoldImod  Auto  
ImageSpaceModifier Property FadeToBlackBackImod  Auto  

Actor Property PlayerRef Auto

float Function GetReducedSkillMult(int Skill)
	return Math.Pow(GetSkillMult(Skill), 0.5)
endFunction

float Function GetSkillMult(int Skill)
	float SkillVal = 25.0
	if(Skill == 6)		;Onehanded
		SkillVal = PlayerRef.GetActorValue("OneHanded")
	elseif(Skill == 7)	;Twohanded
		SkillVal = PlayerRef.GetActorValue("TwoHanded")
	elseif(Skill == 8)	;Marksman
		SkillVal = PlayerRef.GetActorValue("Marksman")
	elseif(Skill == 9)	;Block
		SkillVal = PlayerRef.GetActorValue("Block")
	elseif(Skill == 10)	;Smithing
		SkillVal = PlayerRef.GetActorValue("Smithing")
	elseif(Skill == 11)	;Heavy Armor
		SkillVal = PlayerRef.GetActorValue("HeavyArmor")
	elseif(Skill == 12)	;Light Armor
		SkillVal = PlayerRef.GetActorValue("LightArmor")
	elseif(Skill == 13)	;Pickpocket
		SkillVal = PlayerRef.GetActorValue("Pickpocket")
	elseif(Skill == 14)	;Lockpicking
		SkillVal = PlayerRef.GetActorValue("LockPicking")
	elseif(Skill == 15)	;Sneak
		SkillVal = PlayerRef.GetActorValue("Sneak")
	elseif(Skill == 16)	;Alchemy
		SkillVal = PlayerRef.GetActorValue("Alchemy")
	elseif(Skill == 17)	;Speechcraft
		SkillVal = PlayerRef.GetActorValue("SpeechCraft")
	elseif(Skill == 18)	;Alteration
		SkillVal = PlayerRef.GetActorValue("Alteration")
	elseif(Skill == 19)	;Conjuration
		SkillVal = PlayerRef.GetActorValue("Conjuration")
	elseif(Skill == 20)	;Destruction
		SkillVal = PlayerRef.GetActorValue("Destruction")
	elseif(Skill == 21)	;Illusion
		SkillVal = PlayerRef.GetActorValue("Illusion")
	elseif(Skill == 22)	;Restoration
		SkillVal = PlayerRef.GetActorValue("Restoration")
	elseif(Skill == 23)	;Enchanting
		SkillVal = PlayerRef.GetActorValue("Enchanting")
	endIf
	return Math.Pow(SkillVal, 1.5)
endFunction

Function AdvanceSkill(int Skill, float Exp)
	;Debug.Trace("Advancing Skill, Skill: " + Skill + ", Exp: " + Exp)
	if(Skill == 6)		;Onehanded
		Game.AdvanceSkill("OneHanded", 2 * Exp/6.3)
	elseif(Skill == 7)	;Twohanded
		Game.AdvanceSkill("TwoHanded", 2 * Exp/5.95)
	elseif(Skill == 8)	;Marksman
		Game.AdvanceSkill("Marksman", 2 * Exp/9.3)
	elseif(Skill == 9)	;Block
		Game.AdvanceSkill("Block", 2 * Exp/8.1)
	elseif(Skill == 10)	;Smithing
		Game.AdvanceSkill("Smithing", 0.25 * Exp)
	elseif(Skill == 11)	;Heavy Armor
		Game.AdvanceSkill("HeavyArmor", 2 * Exp/3.8)
	elseif(Skill == 12)	;Light Armor
		Game.AdvanceSkill("LightArmor", 2 * Exp/4.0)
	elseif(Skill == 13)	;Pickpocket
		Game.AdvanceSkill("Pickpocket", 0.25 * Exp/8.1)
	elseif(Skill == 14)	;Lockpicking
		Game.AdvanceSkill("LockPicking", 0.25 * Exp/45)
	elseif(Skill == 15)	;Sneak
		Game.AdvanceSkill("Sneak", 0.5 * Exp/11.25)
	elseif(Skill == 16)	;Alchemy
		Game.AdvanceSkill("Alchemy", 1.6 * Exp/0.75)
	elseif(Skill == 17)	;Speechcraft
		Game.AdvanceSkill("SpeechCraft", 2 * Exp/0.36)
	elseif(Skill == 18)	;Alteration
		Game.AdvanceSkill("Alteration", 2 * Exp/3.0)
	elseif(Skill == 19)	;Conjuration
		Game.AdvanceSkill("Conjuration", 2 * Exp/2.1)
	elseif(Skill == 20)	;Destruction
		Game.AdvanceSkill("Destruction", 2 * Exp/1.35)
	elseif(Skill == 21)	;Illusion
		Game.AdvanceSkill("Illusion", 2 * Exp/4.6)
	elseif(Skill == 22)	;Restoration
		Game.AdvanceSkill("Restoration", 2 * Exp/2.0)
	elseif(Skill == 23)	;Enchanting
		Game.AdvanceSkill("Enchanting", Exp/900)
	endIf
endFunction

bool Function IsValidSkill(int Skill)
	if(Skill >= 6 && Skill <= 23)
		return true
	else
		return false
	endIf
endFunction

int Function GetBookSkill(Book SkillBook)
	if(_TS_ListBooksAlchemy.HasForm(SkillBook))
		return 16
	elseif(_TS_ListBooksAlteration.HasForm(SkillBook))
		return 18
	elseif(_TS_ListBooksBlock.HasForm(SkillBook))
		return 9
	elseif(_TS_ListBooksConjuration.HasForm(SkillBook))
		return 19
	elseif(_TS_ListBooksDestruction.HasForm(SkillBook))
		return 20
	elseif(_TS_ListBooksEnchanting.HasForm(SkillBook))
		return 23
	elseif(_TS_ListBooksHeavyArmor.HasForm(SkillBook))
		return 11
	elseif(_TS_ListBooksIllusion.HasForm(SkillBook))
		return 21
	elseif(_TS_ListBooksLightArmor.HasForm(SkillBook))
		return 12
	elseif(_TS_ListBooksLockpicking.HasForm(SkillBook))
		return 14
	elseif(_TS_ListBooksMarksman.HasForm(SkillBook))
		return 8
	elseif(_TS_ListBooksOneHanded.HasForm(SkillBook))
		return 6
	elseif(_TS_ListBooksPickpocket.HasForm(SkillBook))
		return 13
	elseif(_TS_ListBooksRestoration.HasForm(SkillBook))
		return 22
	elseif(_TS_ListBooksSmithing.HasForm(SkillBook))
		return 10
	elseif(_TS_ListBooksSneak.HasForm(SkillBook))
		return 15
	elseif(_TS_ListBooksSpeechcraft.HasForm(SkillBook))
		return 17
	elseif(_TS_ListBooksTwoHanded.HasForm(SkillBook))
		return 7
	else
		return -1
	endIf
endFunction

int Function GetWeaponSkill(Weapon SkillWeapon)
	int WeaponType = SkillWeapon.GetWeaponType()
	if(WeaponType == 1 || WeaponType == 2 || WeaponType == 3 || WeaponType == 4)
		return 6
	elseif(WeaponType == 5 || WeaponType == 6)
		return 7
	elseif(WeaponType == 7 || WeaponType == 9)
		return 8
	else
		return -1
	endIf
endFunction

int Function GetSpellSkill(Spell SkillSpell)
	Perk SkillPerk = SkillSpell.GetPerk()
	if(_TS_ListPerkAlteration.HasForm(SkillPerk))
		return 18
	elseif(_TS_ListPerkConjuration.HasForm(SkillPerk))
		return 19
	elseif(_TS_ListPerkDestruction.HasForm(SkillPerk))
		return 20
	elseif(_TS_ListPerkIllusion.HasForm(SkillPerk))
		return 21
	elseif(_TS_ListPerkRestoration.HasForm(SkillPerk))
		return 22
	else
		return -1
	endIf
endFunction

bool Function ItemHasKeyword(Form Item, FormList Keywords)
	int Index = Keywords.GetSize() - 1
	while(Index >= 0)
		if(Item.HasKeyword(Keywords.GetAt(Index) as Keyword))
			return true
		endIf
		Index -= 1
	endWhile
	return false
endFunction

Function Train(int Skill, float Exp, int Strength, bool Stamina, Message HoursMessage, Message TiredMessage, Idle StartIdle, Sound TrainSound)
	int Hours = HoursMessage.Show() + 1
	if(Hours != 7)
		Game.DisablePlayerControls()
		PlayerRef.PlayIdle(StartIdle)
		Utility.Wait(2)
		FadeToBlackImod.Apply()
		Utility.Wait(2)
		FadeToBlackImod.PopTo(FadeToBlackHoldImod)
		TrainSound.PlayandWait(PlayerRef)
		TrainSound.PlayandWait(PlayerRef)
		TrainSound.PlayandWait(PlayerRef)
		int Exhaustion = Strength * Hours
		if(Stamina)
			float StaminaAV = PlayerRef.GetActorValue("Stamina")
			if(StaminaAV < Exhaustion * 10)
				Hours = (StaminaAV/(10 * Strength)) as int
				Exhaustion = Hours * Strength
				TiredMessage.Show()
			endIf
			UpdateExhaustion(Stamina, Exhaustion)
		else
			float MagickaAV = PlayerRef.GetActorValue("Magicka")
			if(MagickaAV < Exhaustion * 10)
				Hours = (MagickaAV/(10 * Strength)) as int
				Exhaustion = Hours * Strength
				TiredMessage.Show()
			endIf
			UpdateExhaustion(Stamina, Exhaustion)
		endIf
		AdvanceSkill(Skill, Hours * Exp * GetSkillMult(Skill))
		AdvangeGameHour(Hours)
		Utility.Wait(2)
		FadeToBlackHoldImod.PopTo(FadeToBlackBackImod)
		FadeToBlackHoldImod.Remove()
		PlayerRef.PlayIdle(IdleStop_Loose)
		Game.EnablePlayerControls()
	endIf
endFunction

Function UpdateExhaustion(bool Stamina, int Exhaustion)
	if(Stamina)
		if(_TS_GlobalDrainedStamina.GetValue() <= _TS_ListSpellsTrainedStamina.GetSize() || _TS_GlobalDrainedStamina.GetValue() + Exhaustion <= _TS_ListSpellsTrainedStamina.GetSize())
			int Index = _TS_ListSpellsTrainedStamina.GetSize() - 1
			while(Index >= 0 && PlayerRef.HasMagicEffectWithKeyword(_TS_KeywordTrainedStamina))
				Spell TempSpell = _TS_ListSpellsTrainedStamina.GetAt(Index) as Spell
				if(PlayerRef.HasSpell(TempSpell))
					PlayerRef.RemoveSpell(TempSpell)
				endIf
				Index -= 1
			endWhile
			_TS_GlobalDrainedStamina.Mod(Exhaustion)
			if(_TS_GlobalDrainedStamina.GetValue() < 0)
				_TS_GlobalDrainedStamina.SetValue(0)
			elseif(_TS_GlobalDrainedStamina.GetValue() <= _TS_ListSpellsTrainedStamina.GetSize())
				PlayerRef.AddSpell(_TS_ListSpellsTrainedStamina.GetAt((_TS_GlobalDrainedStamina.GetValue() - 1) as int) as Spell, false)
			else
				PlayerRef.AddSpell(_TS_ListSpellsTrainedStamina.GetAt((_TS_ListSpellsTrainedStamina.GetSize() - 1) as int) as Spell, false)
			endIf
		endIf
	else
		if(_TS_GlobalDrainedMagicka.GetValue() <= _TS_ListSpellsTrainedMagicka.GetSize() || _TS_GlobalDrainedMagicka.GetValue() + Exhaustion <= _TS_ListSpellsTrainedMagicka.GetSize())
			int Index = _TS_ListSpellsTrainedMagicka.GetSize() - 1
			while(Index >= 0 && PlayerRef.HasMagicEffectWithKeyword(_TS_KeywordTrainedMagicka))
				Spell TempSpell = _TS_ListSpellsTrainedMagicka.GetAt(Index) as Spell
				if(PlayerRef.HasSpell(TempSpell))
					PlayerRef.RemoveSpell(TempSpell)
				endIf
				Index -= 1
			endWhile
			_TS_GlobalDrainedMagicka.Mod(Exhaustion)
			if(_TS_GlobalDrainedMagicka.GetValue() < 0)
				_TS_GlobalDrainedMagicka.SetValue(0)
			elseif(_TS_GlobalDrainedMagicka.GetValue() <= _TS_ListSpellsTrainedMagicka.GetSize())
				PlayerRef.AddSpell(_TS_ListSpellsTrainedMagicka.GetAt((_TS_GlobalDrainedMagicka.GetValue() - 1) as int) as Spell, false)
			else
				PlayerRef.AddSpell(_TS_ListSpellsTrainedMagicka.GetAt((_TS_ListSpellsTrainedMagicka.GetSize() - 1) as int) as Spell, false)
			endIf
		endIf
	endIf
endFunction

Function AdvangeGameHour(int Hours)
	GameHour.Mod(Hours)
	if(Hours == 1)
		Debug.Notification("1 hour has passed.")
	else
		Debug.Notification(Hours + " hours have passed.")
	endIf
endFunction